function [imgs, r_labs] = loadPunctImgs2(imgparent, probe_name , parentdir)

% imgparent = '/Users/Tmajarian/Documents/CMU/Murphylab/seema/images';

probe_name = lower(probe_name);

if strcmpi(probe_name,'rxn_1')
    imgdir = dir([imgparent filesep probe_name filesep '*.ics']);
else
    imgdir = dir([imgparent filesep 'probe_' probe_name filesep '*.ics']);
end

%img_files = cell(1,(length(imgdir)));
img_files = {};
for i=1:length(imgdir)
    cur_img = imgdir(i).name;
    if ~strcmpi(cur_img(1),'.');
        img_files{end+1} = imgdir(i).name;
    end
end

imgs = cell(1,length(img_files));
for i = 1:length(img_files)
    if strcmpi(probe_name,'rxn_1')
        imgs{i} = bfOpen3DVolume([imgparent filesep probe_name filesep img_files{i}]);
    else
        imgs{i} = bfOpen3DVolume([imgparent filesep 'probe_' probe_name filesep img_files{i}]);
    end
end

channels = cell(5,length(imgs));
for i = 1:length(imgs)
    z = size(imgs{i}{1}{1},3)/5;
    for j = 1:5
        channels{j,i} = imgs{i}{1}{1}(:,:,j*z-z+1:j*z);
    end
end

imgs = channels;

[~,all_channel_labels,~] = xlsread([parentdir filesep 'data/key_to_probes.xlsx'], 'Sheet1', 'A12:E26');

probe_labels = all_channel_labels(:,1);
if probe_name == 'rxn_1'
    cur_index = strcmpi(probe_labels, 'Rxn 1');    
else
    cur_index = strcmpi(probe_labels, probe_name);
end

channel_labels = all_channel_labels(cur_index==1,:);
r_labs = {};
for c=1:numel(channel_labels)
    if strcmpi(channel_labels{c},'Rxn 1')
        r_labs{end+1} = 'rxn_1';
    elseif strcmpi(channel_labels{c},'M ')
        r_labs{end+1} = 'M';
    elseif strcmpi(channel_labels{c},'')
        continue
    else
        r_labs{end+1} = channel_labels{c};
    end
end
