setup
savedir = [resparent filesep 'imgdat'];

if ~exist(savedir, 'dir')
    mkdir(savedir)
end

z_scale = 0.167847/0.048100;

probes = {'a','b','c','d','e','f','g','h','i','j','k','l','m','rxn_1'};

for p = 1:numel(probes)
    curprobe = probes{p};
                        
    [prot_imgs, chanlabels] = loadPunctImgs2(imgparent, curprobe, parentdir);
    chanlabels = chanlabels(2:end);
                    
    for num =1:size(prot_imgs,2);
        tmpfile = [savedir filesep curprobe num2str(num) '.tmp'];
        if ~exist(tmpfile, 'file')
            system(['touch ' tmpfile]);
                        
                                             
            filtimgdir = dir([parentdir filesep 'fourfilt' filesep curprobe num2str(num) '*.tif']);
            filtfiles = cell(1,(length(filtimgdir)));

            for i=1:length(filtimgdir)
                filtfiles(i) = {filtimgdir(i).name};
            end


            filtimgs = cell(1,length(filtfiles));
            for i = 1:length(filtfiles)
                filtimgs{i} = ml_readimage([parentdir filesep 'fourfilt' filesep filtfiles{i}]);
                if size(filtimgs{i},3)~=size(prot_imgs{i,num},3)
                    filtimgs{i} = zeros(size(prot_imgs{i,num}));
                end
            end
            
            cmaskfile = [imgparent filesep 'tifs' filesep curprobe num2str(num) 'mask.tif'];
            cmask = ml_readimage(cmaskfile);
            cmask = imcomplement(cmask);
            
%             shed = watershed(cmask);
            shed = bwlabeln(cmask);
            uniqval = unique(shed);
            uniqval = uniqval(uniqval>0);
            
            c_savefilebase = [savedir filesep curprobe num2str(num) 'cell'];
            n_savefilebase = [savedir filesep curprobe num2str(num) 'nuc' ];
            disp(['processing img num ', curprobe num2str(num)])
            
            for val=1:numel(uniqval)
                segmask = shed;
                segmask(segmask~=uniqval(val)) = 0;
%                 segmask = segmask.*imcomplement(cmask);
                segmask = double(logical(segmask));
                seg_channels = cell(size(prot_imgs,1),1);
                seg_filt = cell(size(prot_imgs,1),1);
                
                for chan = 1:size(prot_imgs,1)
                    img = double(prot_imgs{chan,num});
                    fimg = double(filtimgs{chan});
                    for slice=1:size(prot_imgs{chan,num},3)
                        curs_img = img(:,:,slice).*segmask;
                        curs_fimg = fimg(:,:,slice).*segmask;
                        img(:,:,slice) = curs_img;
                        fimg(:,:,slice) = curs_fimg;
                    end
                    seg_channels{chan} = img;
                    seg_filt{chan} = fimg;

%                     seg_channels{chan} = double(prot_imgs{chan,num}).*segmask;
%                     seg_filt{chan} = double(filtimgs{chan}).*segmask;
                end
            
                
%                 Get nuclear mask
    
                nuc_img = seg_channels{1};
                nucmask = nuc_img;
                for i=1:size(nucmask,3)
                    slice = imfilter(bwareaopen(imfill(nucmask(:,:,i),'holes'),3000,4),fspecial('gaussian',10,15));
                    nucmask(:,:,i) = slice;
                end
                cc = bwconncomp(nucmask);
                numPixels = cellfun(@numel,cc.PixelIdxList);
                [biggest,idx] = max(numPixels);
                for sidx = 1:numel(cc.PixelIdxList)
                    if sidx == idx
                        continue
                    end
                    nucmask(cc.PixelIdxList{sidx}) = 0;
                end
                
                segmask = repmat(segmask,[1 1 size(nucmask,3)]);
                    
%                 bound_box = struct();
                [row,col,z] = ind2sub(size(segmask),find(segmask>0));
                
%                 bound_box.col_start = min(col);
%                 bound_box.col_end = max(col);
%                 bound_box.row_start = min(row);
%                 bound_box.row_end = max(row);
%                 bound_box.z_start = min(z);
%                 bound_box.z_end = max(z);
                
                rrange = min(row):max(row);
                crange = min(col):max(col);
                zrange = min(z):max(z);
                
                segmask = bwperim(segmask(rrange,crange,zrange));
                nucmask = nucmask(rrange,crange,zrange);
                nucsub = nucmask;
                
                chan_regs = cell(size(prot_imgs,1),1);
                fchan_regs = cell(size(prot_imgs,1),1);
                
                for chan = 1:size(prot_imgs,1)
                    creg = seg_channels{chan};
                    freg = seg_filt{chan};
                    chan_regs{chan} = creg(rrange,crange,zrange).*imcomplement(nucsub);
                    fchan_regs{chan} = freg(rrange,crange,zrange).*imcomplement(nucsub);
                end
                
                
                for slice=1:size(nucmask,3)
                    cursl = bwperim(nucmask(:,:,slice));
                    nucmask(:,:,slice) = cursl;
                end
                
                cellpts = struct();
                nucpts = struct();
                
                [row,col,z] = ind2sub(size(segmask),find(segmask>0));
                cellpts.row = row;
                cellpts.col = col;
                cellpts.z = z;
                
                [row,col,z] = ind2sub(size(nucmask),find(nucmask>0));
                nucpts.row = row;
                nucpts.col = col;
                nucpts.z = z;
                
%                 properties = {'BoundingBox'};
%                 stats = regionprops(segmask,properties);
% 
%                 if numel(stats) > 1
%                     bb = [];
% 
%                     for s=1:numel(stats)
%                         if sum(stats(s).BoundingBox) > sum(bb)
%                             bb = floor(stats(s).BoundingBox);
%                         end
%                     end
%                 else
%                     bb = floor(stats.BoundingBox);
%                 end
% 
%                 for bb_ind = 1:numel(bb)
%                     if bb(bb_ind) == 0
%                         bb(bb_ind) = 1;
%                     end
%                 end
% 
%                 bound_box.col_start = bb(1);
%                 bound_box.col_end = bb(1) + bb(4);
%                 bound_box.row_start = bb(2);
%                 bound_box.row_end = bb(2) + bb(5);
%                 bound_box.z_start = bb(3);
%                 bound_box.z_end = bb(3) + bb(6);
% 
%                 if bound_box.col_end > size(segmask,2)
%                     bound_box.col_end = size(segmask,2);
%                 end
% 
%                 if bound_box.row_end > size(segmask,1)
%                     bound_box.row_end = size(segmask,1);
%                 end
% 
%                 if bound_box.z_end > size(segmask,3)
%                     bound_box.z_end = size(segmask,3);
%                 end
                
                % find the convex hull of the cell
%                 [row,col,z] = ind2sub(size(segmask),find(segmask>0));
%                 hull_inds = convhulln([row,col,z]);
%                 cell_pts.row = [];
%                 cell_pts.col = [];
%                 cell_pts.z = [];

%                 for ind=1:numel(hull_inds)
%                     [R,C,Z] = ind2sub(size(segmask),hull_inds(ind));
%                     cell_pts.row(end+1) = R;
%                     cell_pts.col(end+1) = C;
%                     cell_pts.z(end+1) = Z;
%                 end
% 
%                 cell_pts.row = cell_pts.row';
%                 cell_pts.col = cell_pts.col';
%                 cell_pts.z = cell_pts.z';
%                 
%                 row_range = bound_box.row_start:bound_box.row_end;
%                 col_range = bound_box.col_start:bound_box.col_end;
%                 z_range = bound_box.z_start:bound_box.z_end;
%                 
%                 
%                 cell_pts = struct();
%                 segmask = segmask(row_range,col_range,z_range);
%                 
%                 [row,col,z] = ind2sub(size(segmask),find(segmask>0));
%                 hull_inds = convhulln([row,col,z]);
%                 cell_pts.row = [];
%                 cell_pts.col = [];
%                 cell_pts.z = [];
% 
%                 for ind=1:numel(hull_inds)
%                     [R,C,Z] = ind2sub(size(segmask),hull_inds(ind));
%                     cell_pts.row(end+1) = R;
%                     cell_pts.col(end+1) = C;
%                     cell_pts.z(end+1) = Z;
%                 end
% 
%                 cell_pts.row = cell_pts.row';
%                 cell_pts.col = cell_pts.col';
%                 cell_pts.z = cell_pts.z';
%                 
                
                
%                 dna_region = nucmask(row_range,col_range,z_range);
                
%                 dna_region = nucmask;

%                 if max(dna_region(:)) == 0
%                     continue
%                 end
% 
%                 [row,col,z] = ind2sub(size(dna_region),find(dna_region>0));
%                 hull_inds = convhulln([row,col,z]);
%                 dna_pts.row = [];
%                 dna_pts.col = [];
%                 dna_pts.z = [];
% 
%                 for ind=1:numel(hull_inds)
%                     [R,C,Z] = ind2sub(size(segmask),hull_inds(ind));
%                     dna_pts.row(end+1) = R;
%                     dna_pts.col(end+1) = C;
%                     dna_pts.z(end+1) = Z;
%                 end
% 
%                 dna_pts.row = dna_pts.row';
%                 dna_pts.col = dna_pts.col';
%                 dna_pts.z = dna_pts.z';
                                
                
                
                
                
%                 
%                 chan_regs = cell(size(prot_imgs,1),1);
%                 fchan_regs = cell(size(prot_imgs,1),1);
%                 
%                 for chan = 1:size(prot_imgs,1)
%                     creg = seg_channels{chan};
%                     freg = seg_filt{chan};
%                     chan_regs{chan} = creg(row_range,col_range,z_range);
%                     fchan_regs{chan} = freg(row_range,col_range,z_range);
%                 end
                
                 
                
%                 mincube = segmask(row_range,col_range,z_range);
%                 mincube = segmask;
%                 for z=1:size(mincube,3)
%                     curslice = mincube(:,:,z);
%                     m = mode(mode(curslice));
%                     curslice(curslice~=m) = 0;
%                     curslice(curslice==m) = 1;
%                     if sum(curslice(:)>0)>2000
%                         mincube(:,:,z) = curslice;
%                     else
%                         mincube(:,:,z) = zeros(size(curslice));
%                     end
%                 end
%                 
%                 for chan = 1:size(prot_imgs,1)
%                     creg = chan_regs{chan};
%                     creg(mincube==0) = 0;
%                     freg = fchan_regs{chan};
%                     freg(mincube==0) = 0;
%                     chan_regs{chan} = creg;
%                     fchan_regs{chan} = freg;
%                 end
%                 nucreg(mincube == 0) = 0;

% % % % % % % % % % % % % % % % % % % % %                 
                disp(['segmenting proteins'])
                p_centers = cell(numel(chan_regs)-1,1);
                for chan=2:numel(chan_regs)
%                     [~,~,pdn] = segmentProt(fchan_regs{chan});
                    [~,~,pdn] = segmentProt(chan_regs{chan},1.5, 5);
                
                    [p1ob] = ml_findobjs(pdn);
                    p1obfinal=[];k=1;
                    for i=1:length(p1ob)
                        if (size(p1ob{i},1)>=4)
                            p1obfinal{k}=p1ob{i};
                            k=k+1;
                        else
                            pdn(p1ob{i}(:,1),p1ob{i}(:,2),p1ob{i}(:,3)) = 0;
                        end
                    end
                    %find centers
                    p1labels=bwlabeln(pdn,26);
                    objnum=max(p1labels(:));

                    p1centers=[];
                    for k = 1:objnum
                        p1posxyz=find(p1labels==k);
                        [p1X,p1Y,p1Z] = ind2sub(size(pdn),p1posxyz);
                        v=pdn(p1labels == k);
                        pos = find(v==max(v));
                        %p1centers = [p1centers;[lab_x(pos) lab_y(pos)]];
                        p1centers = [p1centers;[p1X(pos) p1Y(pos) p1Z(pos)*z_scale]];        
                    end
                    p_centers{chan-1} = p1centers;
                end
                

                nucedgeXYZ = [nucpts.row, nucpts.col, nucpts.z*z_scale];
                celledgeXYZ = [cellpts.row, cellpts.col, cellpts.z*z_scale];
%                 box = [bound_box.row_start, bound_box.row_end, bound_box.col_start, bound_box.col_end, bound_box.z_start*z_scale, bound_box.z_end*z_scale ]; 

                

                datsavedir = [resparent filesep 'imgdat' filesep curprobe num2str(num) num2str(val)];
                
                for chan=1:numel(p_centers)
                    
                    p1save = [datsavedir 'prot' chanlabels{chan} '.txt'];
                    psave = p_centers{chan};
                    save(p1save,'psave','-ASCII')
                end
                
                properties = {'Area'};
                stats = regionprops(segmask,properties);
                cellvol = stats.Area*z_scale;
                
                cellvolsave = [datsavedir 'cellarea.txt'];
%                 boxsave = [datsavedir 'boxsave.txt'];
                cellsave = [datsavedir 'cell.txt'];
                nucsave = [datsavedir 'nuc.txt'];


                
                save(cellvolsave,'cellvol','-ASCII')
%                 save(boxsave,'box','-ASCII')
                save(cellsave,'celledgeXYZ','-ASCII')
                save(nucsave,'nucedgeXYZ','-ASCII')

            end
        end
                        
                        %cell_segs{i} = cell_seg;
                        %nuc_masks{i} = nuc_mask;
    end
end
            
        
    


    
